/*
 * Created on 2004/06/02
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interview;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

/**
* AbstractInvigilateBehavior
*/
public abstract class AbstractInvigilateBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waiting_For_TestTaker =
			factory.createCompositeState("Waiting For TestTaker");
		CompositeState waiting_For_Sit_Down =
			factory.createCompositeState("Waiting For Sit Down");
		CompositeState waiting_For_Name =
			factory.createCompositeState("Waiting For Name");
		CompositeState waiting_For_School_Name =
			factory.createCompositeState("Waiting For School Name");
		CompositeState waiting_For_Money =
			factory.createCompositeState("Waiting For Money");
		CompositeState waiting_For_Thanks =
			factory.createCompositeState("Waiting For Thanks");

		//actions
		Action askNameAction = new Action() {
			public void doAction() {
				askNameAction();
			}
			public String toString() {
				return "askNameAction";
			}
		};
		Action demandMoneyAction = new Action() {
			public void doAction() {
				demandMoneyAction();
			}
			public String toString() {
				return "demandMoneyAction";
			}
		};
		Action allowSitDownAction = new Action() {
			public void doAction() {
				allowSitDownAction();
			}
			public String toString() {
				return "allowSitDownAction";
			}
		};
		Action sayPassAction = new Action() {
			public void doAction() {
				sayPassAction();
			}
			public String toString() {
				return "sayPassAction";
			}
		};
		Action askCollegeAction = new Action() {
			public void doAction() {
				askCollegeAction();
			}
			public String toString() {
				return "askCollegeAction";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionWaiting_For_NameToWaiting_For_School_Name =
			factory.createTransition();
		Transition transitionWaiting_For_School_NameToWaiting_For_Money =
			factory.createTransition();
		Transition transitionWaiting_For_ThanksToWaiting_For_TestTaker =
			factory.createTransition();
		Transition transitionWaiting_For_TestTakerToWaiting_For_Sit_Down =
			factory.createTransition();
		Transition transitionWaiting_For_Sit_DownToWaiting_For_Name =
			factory.createTransition();
		Transition transitionWaiting_For_MoneyToWaiting_For_Thanks =
			factory.createTransition();
		Transition transitionInitialStateToWaiting_For_TestTaker =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waiting_For_TestTaker);
		this.addState(waiting_For_Sit_Down);
		this.addState(waiting_For_Name);
		this.addState(waiting_For_School_Name);
		this.addState(waiting_For_Money);
		this.addState(waiting_For_Thanks);

		//transitions setting
		transitionWaiting_For_NameToWaiting_For_School_Name.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_NameToWaiting_For_School_Name.addAction(
			askCollegeAction);
		transitionWaiting_For_School_NameToWaiting_For_Money.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_School_NameToWaiting_For_Money.addAction(
			demandMoneyAction);
		transitionWaiting_For_ThanksToWaiting_For_TestTaker.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_TestTakerToWaiting_For_Sit_Down.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_TestTakerToWaiting_For_Sit_Down.addAction(
			allowSitDownAction);
		transitionWaiting_For_Sit_DownToWaiting_For_Name.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_Sit_DownToWaiting_For_Name.addAction(
			askNameAction);
		transitionWaiting_For_MoneyToWaiting_For_Thanks.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_MoneyToWaiting_For_Thanks.addAction(
			sayPassAction);

		//connection of transitions
		transitionWaiting_For_NameToWaiting_For_School_Name.setSourceState(
			waiting_For_Name);
		transitionWaiting_For_NameToWaiting_For_School_Name.setTargetState(
			waiting_For_School_Name);
		transitionWaiting_For_School_NameToWaiting_For_Money.setSourceState(
			waiting_For_School_Name);
		transitionWaiting_For_School_NameToWaiting_For_Money.setTargetState(
			waiting_For_Money);
		transitionWaiting_For_ThanksToWaiting_For_TestTaker.setSourceState(
			waiting_For_Thanks);
		transitionWaiting_For_ThanksToWaiting_For_TestTaker.setTargetState(
			waiting_For_TestTaker);
		transitionWaiting_For_TestTakerToWaiting_For_Sit_Down.setSourceState(
			waiting_For_TestTaker);
		transitionWaiting_For_TestTakerToWaiting_For_Sit_Down.setTargetState(
			waiting_For_Sit_Down);
		transitionWaiting_For_Sit_DownToWaiting_For_Name.setSourceState(
			waiting_For_Sit_Down);
		transitionWaiting_For_Sit_DownToWaiting_For_Name.setTargetState(
			waiting_For_Name);
		transitionWaiting_For_MoneyToWaiting_For_Thanks.setSourceState(
			waiting_For_Money);
		transitionWaiting_For_MoneyToWaiting_For_Thanks.setTargetState(
			waiting_For_Thanks);
		transitionInitialStateToWaiting_For_TestTaker.setSourceState(
			initialState);
		transitionInitialStateToWaiting_For_TestTaker.setTargetState(
			waiting_For_TestTaker);

	}

	/**
	*askNameAction
	*/
	protected abstract void askNameAction();
	/**
	*demandMoneyAction
	*/
	protected abstract void demandMoneyAction();
	/**
	*allowSitDownAction
	*/
	protected abstract void allowSitDownAction();
	/**
	*sayPassAction
	*/
	protected abstract void sayPassAction();
	/**
	*askCollegeAction
	*/
	protected abstract void askCollegeAction();
}
