/*
 * Created on 2004/06/02
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package interview;

import org.boxed_economy.besp.model.fmfw.ChannelEvent;
import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;

/**
* AbstractTakeExamBehavior
*/
public abstract class AbstractTakeExamBehavior extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waiting_For_Time =
			factory.createCompositeState("Waiting For Time");
		CompositeState waiting_For_Allowing =
			factory.createCompositeState("Waiting For Allowing");
		CompositeState waiting_For_Question =
			factory.createCompositeState("Waiting For Question");
		CompositeState waiting_For_Question2 =
			factory.createCompositeState("Waiting For Question2");
		CompositeState waiting_For_Demand =
			factory.createCompositeState("Waiting For Demand");
		CompositeState waiting_For_Pass =
			factory.createCompositeState("Waiting For Pass");

		//actions
		Action sayHelloAction = new Action() {
			public void doAction() {
				sayHelloAction();
			}
			public String toString() {
				return "sayHelloAction";
			}
		};
		Action sayCollegeAction = new Action() {
			public void doAction() {
				sayCollegeAction();
			}
			public String toString() {
				return "sayCollegeAction";
			}
		};
		Action greetingAction = new Action() {
			public void doAction() {
				greetingAction();
			}
			public String toString() {
				return "greetingAction";
			}
		};
		Action givingMoneyAction = new Action() {
			public void doAction() {
				givingMoneyAction();
			}
			public String toString() {
				return "givingMoneyAction";
			}
		};
		Action sayThanksAction = new Action() {
			public void doAction() {
				sayThanksAction();
			}
			public String toString() {
				return "sayThanksAction";
			}
		};
		Action sayNameAction = new Action() {
			public void doAction() {
				sayNameAction();
			}
			public String toString() {
				return "sayNameAction";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionInitialStateToWaiting_For_Time =
			factory.createTransition();
		Transition transitionWaiting_For_DemandToWaiting_For_Pass =
			factory.createTransition();
		Transition transitionWaiting_For_AllowingToWaiting_For_Question =
			factory.createTransition();
		Transition transitionWaiting_For_QuestionToWaiting_For_Question2 =
			factory.createTransition();
		Transition transitionWaiting_For_PassToWaiting_For_Time =
			factory.createTransition();
		Transition transitionWaiting_For_Question2ToWaiting_For_Demand =
			factory.createTransition();
		Transition transitionWaiting_For_TimeToWaiting_For_Allowing =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waiting_For_Time);
		this.addState(waiting_For_Allowing);
		this.addState(waiting_For_Question);
		this.addState(waiting_For_Question2);
		this.addState(waiting_For_Demand);
		this.addState(waiting_For_Pass);

		//transitions setting
		transitionWaiting_For_DemandToWaiting_For_Pass.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_DemandToWaiting_For_Pass.addAction(
			givingMoneyAction);
		transitionWaiting_For_AllowingToWaiting_For_Question.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_AllowingToWaiting_For_Question.addAction(
			greetingAction);
		transitionWaiting_For_QuestionToWaiting_For_Question2.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_QuestionToWaiting_For_Question2.addAction(
			sayNameAction);
		transitionWaiting_For_PassToWaiting_For_Time.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_PassToWaiting_For_Time.addAction(sayThanksAction);
		transitionWaiting_For_Question2ToWaiting_For_Demand.setEvent(
			ChannelEvent.class);
		transitionWaiting_For_Question2ToWaiting_For_Demand.addAction(
			sayCollegeAction);
		transitionWaiting_For_TimeToWaiting_For_Allowing.setEvent(
			TimeEvent.class);
		transitionWaiting_For_TimeToWaiting_For_Allowing.addAction(
			sayHelloAction);

		//connection of transitions
		transitionInitialStateToWaiting_For_Time.setSourceState(initialState);
		transitionInitialStateToWaiting_For_Time.setTargetState(
			waiting_For_Time);
		transitionWaiting_For_DemandToWaiting_For_Pass.setSourceState(
			waiting_For_Demand);
		transitionWaiting_For_DemandToWaiting_For_Pass.setTargetState(
			waiting_For_Pass);
		transitionWaiting_For_AllowingToWaiting_For_Question.setSourceState(
			waiting_For_Allowing);
		transitionWaiting_For_AllowingToWaiting_For_Question.setTargetState(
			waiting_For_Question);
		transitionWaiting_For_QuestionToWaiting_For_Question2.setSourceState(
			waiting_For_Question);
		transitionWaiting_For_QuestionToWaiting_For_Question2.setTargetState(
			waiting_For_Question2);
		transitionWaiting_For_PassToWaiting_For_Time.setSourceState(
			waiting_For_Pass);
		transitionWaiting_For_PassToWaiting_For_Time.setTargetState(
			waiting_For_Time);
		transitionWaiting_For_Question2ToWaiting_For_Demand.setSourceState(
			waiting_For_Question2);
		transitionWaiting_For_Question2ToWaiting_For_Demand.setTargetState(
			waiting_For_Demand);
		transitionWaiting_For_TimeToWaiting_For_Allowing.setSourceState(
			waiting_For_Time);
		transitionWaiting_For_TimeToWaiting_For_Allowing.setTargetState(
			waiting_For_Allowing);

	}

	/**
	*sayHelloAction
	*/
	protected abstract void sayHelloAction();
	/**
	*sayCollegeAction
	*/
	protected abstract void sayCollegeAction();
	/**
	*greetingAction
	*/
	protected abstract void greetingAction();
	/**
	*givingMoneyAction
	*/
	protected abstract void givingMoneyAction();
	/**
	*sayThanksAction
	*/
	protected abstract void sayThanksAction();
	/**
	*sayNameAction
	*/
	protected abstract void sayNameAction();
}
